@echo off
rem rollback_chkr.cmd
rem One argument: desired release number (optional -- takes previous release if not present.)
rem version 171027
rem Copyright 2006-2017 Nova Software, www.nova-sw.com
rem update zip file must be in the base dir or in bak. 
setlocal enableextensions disabledelayedexpansion
echo START an Appchkr rollback to %1  1>>rollback_chkr.log
date /t 1>>rollback_chkr.log
time /t 1>>rollback_chkr.log

if not exist chkr_release_nbr.txt ( 
    echo Missing chkr_release_nbr.txt file.  Cannot rollback  1>> rollback_chkr.log 
    prl\bin\perl subvar.pl  msg\rlbk\r_msng_relnbr.txt   2>>rollback_chkr.log
    pause
    goto :EOF
) else (
    set /p chkr_rel_nbr=<chkr_release_nbr.txt  2>>rollback_chkr.log
) 2>&1
echo chkr rel nbr is %chkr_rel_nbr%   1>>rollback_chkr.log

if not [%1] == [] (
    set /p rlbk_rel_nbr=%1  2>>rollback_chkr.log
) else (
    set /p rlbk_rel_nbr=<chkr_prv_release_nbr.txt  2>>rollback_chkr.log
)

if [%rlbk_rel_nbr%] == [] (
    echo Missing rollback release number  1>>rollback_chkr.log
    prl\bin\perl subvar.pl  msg\rlbk\r_no_arg.txt   2>>rollback_chkr.log
    pause
    goto :EOF
) 2>&1

if not %rlbk_rel_nbr% lss %chkr_rel_nbr%  (
    echo Rollback release number must be earlier than existing release.  No rollback.  1>>rollback_chkr.log 
    prl\bin\perl subvar.pl  msg\rlbk\r_hi_rlbk_nbr.txt  %rlbk_rel_nbr%  %chkr_rel_nbr%     2>>rollback_chkr.log
    pause
    goto :EOF
) 2>&1
if exist chkr_update_%rlbk_rel_nbr%.zip (
    echo Hiding update file.  1>>rollback_chkr.log
    move /y chkr_update_%rlbk_rel_nbr%.zip chkr_update_%rlbk_rel_nbr%.zip-hide  1>>rollback_chkr.log   2>&1
) 

del /f /q .ignore_update   1>>rollback_chkr.log  2>&1
del /f /q chkr_update_*.zip   1>>rollback_chkr.log   2>&1

if exist chkr_update_%rlbk_rel_nbr%.zip-hide  (
    echo Unhiding update file   1>>rollback_chkr.log
    move /y chkr_update_%rlbk_rel_nbr%.zip-hide  chkr_update_%rlbk_rel_nbr%.zip  1>>rollback_chkr.log   2>&1
) else (
    if exist bak\chkr_update_%rlbk_rel_nbr%.zip  (
        echo Copying update file from bak.    1>>rollback_chkr.log
        copy /b /y bak\chkr_update_%rlbk_rel_nbr%.zip  .   1>>rollback_chkr.log   2>&1
    ) else ( 
        echo No rollback zip  1>>rollback_chkr.log
        prl\bin\perl subvar.pl  msg\rlbk\r_no_zip.txt  %rlbk_rel_nbr%  2>>rollback_chkr.log
        pause
        goto :EOF
    )  2>&1
)
 2>&1

prl\bin\perl subvar.pl  msg\rlbk\r_greet.txt  %chkr_rel_nbr%  %rlbk_rel_nbr%  2>>rollback_chkr.log
set /p do_rollback=
if [%do_rollback%]==[]  goto NO  2>>update_chkr.log
if [%do_rollback%]==[Q] goto NO  2>>update_chkr.log
if [%do_rollback%]==[q] goto NO  2>>update_chkr.log
if [%do_rollback%]==[C] goto RLBK  2>>update_chkr.log
if [%do_rollback%]==[c] goto RLBK  2>>update_chkr.log

:NO
echo Quit  %do_rollback%  1>>rollback_chkr.log
echo Quit -- no rollback.
goto END

:RLBK
echo do_rollback is %do_rollback%  1>>update_chkr.log
bin\7z d chkr_update_%chkr_rel_nbr%.zip  rollback_chkr*
call update_chkr.cmd  rb
call rollback_chkr2.cmd  %rlbk_rel_nbr%  %chkr_rel_nbr% 
echo Rolled back from %chkr_rel_nbr% to %rlbk_rel_nbr%.

:END
date /t  1>>rollback_chkr.log
time /t  1>>rollback_chkr.log
echo End.
echo.
echo.
echo End.   1>>rollback_chkr.log

